#define MAXROW 5000        // maximum size of grid
#define MAXCOL 5000        // dependent on size of screen output

typedef enum state {DEAD,ALIVE} State;    // cell status
typedef State Grid[MAXROW+2][MAXCOL+2];
typedef int Gridcount[MAXROW+2][MAXCOL+2];   // number of neighbors

#ifndef DEF_CELL
#include "celldef.h"
#define DEF_CELL
#endif

#include "simplist.h"

void WriteMap(Grid, int, Cell, Cell);
void usage(void);
void ReadMap(List *, Grid, char*, int*, Cell*, Cell*);
void Vivify(Cell);
void Kill(Cell);
void AddNeighbors(Cell);
void SubtractNeighbors(Cell);
void Initialize(Grid, Gridcount, List *, List *, List *, List *, char*, int*, Cell*, Cell*);

