#include "common.h"
#include "simplist.h"

void CreateList(List *list)
{
	list = new List;
	list->count = 0;
	list->entry = NULL;
}

void ClearList(List *list)
{   ListNode *p = list->entry, *q;

    list->count = 0;
	list->entry = NULL;
    while (!(p == NULL)){
       q = p;
	   p = p->next;
	   delete q;
    }
}

BOOL ListEmpty(const List *list)
{
	if (list->count == 0)
		return TRUE;
	else
		return FALSE;
}

BOOL ListFull(const List *list)
{
	return FALSE;
}

int ListSize(const List *list)
{
	return list->count;
}

void AddList(Cell x, List *list) 
{
    ListNode *l = new ListNode;
	l->data.row = x.row;
	l->data.col = x.col;
	l->next = list->entry;
	list->count++;
	list->entry = l;
}

void TraverseList(List *list, void (*Visit)(Cell))
{
	ListNode *l = list->entry;
	while (!(l == NULL)){
		(*Visit)(l->data);
		l = l->next;
	}
}

void CopyList(List *list1, const List *list2)
{
	ListNode *p = list2->entry;

	ClearList(list1);
	while (!(p == NULL)){
		AddList(p->data, list1);
		p = p->next;
	}
}