using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

using System.Globalization;
[Serializable()]
public  class Result : ISerializable {

 //-------------- MCsharp functions -----------

 public Result ( ) {
  mcsharp_initiate();
}

 public Result ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

 }

public  double Root ;

 public  bool isFound ;

 }

[Serializable()]
public  class FindingRoots : ISerializable {

 //-------------- MCsharp functions -----------

 public FindingRoots ( ) {
  mcsharp_initiate();
}

 public FindingRoots ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  sendResult = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendResult" );
  mcsharpQueuegetResult = new MCSharp.ThreadQ();

  getResult = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetResult" );
 }

public static  double DELTA_X = 0.00000000001  ;

 public static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   int i ;

  double a = 0.0  ;

  double b = 1.0  ;

  int P = 1  ;

  Result result ;

  NumberFormatInfo provider = new NumberFormatInfo ( )   ;

  provider.NumberDecimalSeparator = "."  ;
 if ( args.Length  > 1  )
    {
   a = System.Convert.ToDouble( args[ 0   ]   , provider   )  ;
 b = System.Convert.ToDouble( args[ 1   ]   , provider   )  ;
 }

  if ( args.Length  > 2  )
   P = System.Convert.ToInt32( args[ 2   ]   )  ;

  Console.WriteLine( "\nGiven interval: [ " + a + ", " + b + " ),  number of procs/cores = " + P   )  ;
 double size = ( b - a   ) / P  ;

  FindingRoots fr = new FindingRoots ( )   ;

  for ( i = 0  ; i  < P ; i++   )
 fr.Worker( i * size   , ( i + 1   ) * size   , fr.sendResult   )  ;

  double root = 0.0  ;

  bool isFound = false  ;

  for ( i = 0  ; i  < P ; i++   )
  {
   result = (Result)fr.getResult  .Get(new object[]{ } )
;
 if ( result.isFound   )
    {
   root = result.Root  ;
 isFound = true  ;
 }

  }

  if ( isFound   )
   Console.WriteLine( "The root is " + root   )  ;

  else
 Console.WriteLine( "The root isn't found in given interval ..."   )  ;
 
 }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendResult;

 //-------------Handler declaration-----------------

    public MCSharp.handler getResult;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetResult;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getResult = 1 << 0;
 private const int mcsharp_mask_sendResult = 1 << 1;
 private const int mcsharp_mask_getResultsendResult =
            mcsharp_mask_getResult
          | mcsharp_mask_sendResult;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetResultsendResult = new MCSharp.BitMask();

 private void scangetResultsendResult () {
  if ( mcsharpBitMaskgetResultsendResult.match
        ( mcsharp_mask_getResultsendResult ) )
   mcsharpQueuegetResult.wakeup();
 }


[OneWay]
public void mcsharpChannelsendResult (  Result r )  {
   lock ( mcsharpQueuegetResult ) {
    sendResult.Enqueue ( new object [] { r } );
    if ( ! mcsharpBitMaskgetResultsendResult.match
          ( mcsharp_mask_sendResult ) )   {
     mcsharpBitMaskgetResultsendResult.set ( mcsharp_mask_sendResult );
     scangetResultsendResult ();
    }
   }
 }

 public Result mcsharpHandlergetResult (  )   {
  Monitor.Enter ( mcsharpQueuegetResult );
  if ( ! mcsharpBitMaskgetResultsendResult.match ( mcsharp_mask_getResult ) ) goto now;
  later:
   mcsharpQueuegetResult.yield ( mcsharpQueuegetResult );
   if ( mcsharpQueuegetResult.empty )
    mcsharpBitMaskgetResultsendResult.clear ( mcsharp_mask_getResult );
  now:
   if ( mcsharpBitMaskgetResultsendResult.match ( 
    mcsharp_mask_sendResult ) )   {
    object[] osendResult = ( object[] ) sendResult.Dequeue();
    Result r = ( Result ) osendResult [ 0 ];
    if ( sendResult.Count == 0 )
         mcsharpBitMaskgetResultsendResult.clear ( mcsharp_mask_sendResult );
    scangetResultsendResult ();
    Monitor.Exit ( mcsharpQueuegetResult );
     {
   return ( r   )  ;
  }
   }
   else {
    mcsharpBitMaskgetResultsendResult.set ( mcsharp_mask_getResult );
    goto later;
  }

 }
  private class McsharpPrivateClassWorker {

   FindingRoots parent;
   double a;
   double b;
   channel  sendResult;

   public McsharpPrivateClassWorker ( FindingRoots parent,
               double a,
               double b,
               channel  sendResult
              ) {
    this.parent = parent;
    this.a = a;
    this.b = b;
    this.sendResult = sendResult;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpWorkerBody ( a, b, sendResult );

   }
  }

  private void mcsharpWorkerBody (
               double a,
               double b,
               channel  sendResult
              )
 {
   double c ;

  double Fa = F( a   )  ;

  double Fb = F( b   )  ;

  double Fc ;

  while ( Math.Abs( b - a   )  > DELTA_X  )
  {
   c = a + ( Math.Abs( b - a   ) / 2.0   )  ;
 Fc = F( c   )  ;
 if ( Math.Sign( Fc   )  == Math.Sign( Fa   )   )
    {
   a = c  ;
 Fa = Fc  ;
 }

  else
  {
   b = c  ;
 Fb = Fc  ;
 }
 
 }

  Result result = new Result ( )   ;

  if ( Math.Sign( Fa   )  != Math.Sign( Fb   )   )
    {
   result.isFound = true  ;
 result.Root = a  ;
 }

  else
  {
   result.isFound = false  ;
 result.Root = 0.0  ;
 }
 
 sendResult.Send ( new object[] {  result    } )
  ;
 }




  public  void Worker (  double a,  double b,  channel  sendResult ) {
   McsharpPrivateClassWorker prclassobject = new McsharpPrivateClassWorker ( this, a, b, sendResult );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }
public static  double F (  double x )   {
   double Fx = -2.0  ;

  double arg = 1.0  ;

  for ( int i = 1  ;

  i  <= 1000 ; i++   )
  {
   arg = arg * x  ;
 Fx += Math.Sin( arg   )  ;
 }

  return ( Fx   )  ;
  }
}

