using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

using System.IO;
using System.Text;
[Serializable()]
public  class Mergesort : ISerializable {

 //-------------- MCsharp functions -----------

 public Mergesort ( ) {
  mcsharp_initiate();
}

 public Mergesort ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  sendStop = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendStop" );
  mcsharpQueuegetStop = new MCSharp.ThreadQ();

  getStop = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetStop" );
 }

public static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   int i ;

  int count , size ;

  int P = 1  ;

  int GROUP_SIZE = 10000  ;

  String filename = "InputData.in"  ;

  DateTime dt1 , dt2 , dt00 , dt01 ;

  dt00 = DateTime.Now  ;
 if ( args.Length  > 0  )
   filename = args[ 0   ]  ;

  if ( args.Length  > 1  )
   P = System.Convert.ToInt32( args[ 1   ]   )  ;

  FileStream fs = new FileStream ( filename   , FileMode.Open   , FileAccess.Read   )   ;

  StreamReader sr = new StreamReader ( fs   )   ;

  int N = System.Convert.ToInt32( sr.ReadLine( )   )  ;

  Console.WriteLine( "N = " + N   )  ;
 int[,] x = new int [ 2  , N   ]    ;

  dt1 = DateTime.Now  ;
 for ( i = 0  ; i  < N ; i++   )
 x[ 0  , i   ] = System.Convert.ToInt32( sr.ReadLine( )   )  ;

  dt2 = DateTime.Now  ;
 Console.WriteLine( "read_data: " + ( dt2 - dt1   ).TotalSeconds + " secs."   )  ;
 sr.Close( )  ;
 fs.Close( )  ;
 dt1 = DateTime.Now  ;
 Mergesort ms = new Mergesort ( )   ;

  new MSort ( ) .sort( 1   , 0   , 0   , N   , x   , P   , ms.sendStop   )  ;
 ms.getStop  .Get(new object[]{ } )
;
 dt2 = DateTime.Now  ;
 Console.WriteLine( "sort_time : " + ( dt2 - dt1   ).TotalSeconds + " secs."   )  ;
 StringBuilder sb = new StringBuilder ( GROUP_SIZE * 15   )   ;

  fs = new FileStream ( "sorted.out"   , FileMode.Create   , FileAccess.Write   )   ;
 StreamWriter sw = new StreamWriter ( fs   )   ;

  dt1 = DateTime.Now  ;
 count = 0  ;
 while ( count  < N  )
  {
   if ( count + GROUP_SIZE  <= N  )
   size = GROUP_SIZE  ;

  else
 size = N - count  ;
 
 sb.Length = 0  ;
 for ( i = 0  ; i  < size ; i++   )
  {
   sb.Append( x[ 0  , count + i   ]   )  ;
 sb.Append( "\n"   )  ;
 }

  sw.Write( sb.ToString( )   )  ;
 count += size  ;
 }

  dt2 = DateTime.Now  ;
 Console.WriteLine( "write_data: " + ( dt2 - dt1   ).TotalSeconds + " secs."   )  ;
 sw.Close( )  ;
 fs.Close( )  ;
 dt01 = DateTime.Now  ;
 Console.WriteLine( "Total time: " + ( dt01 - dt00   ).TotalSeconds + " secs."   )  ;
 }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendStop;

 //-------------Handler declaration-----------------

    public MCSharp.handler getStop;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetStop;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getStop = 1 << 0;
 private const int mcsharp_mask_sendStop = 1 << 1;
 private const int mcsharp_mask_getStopsendStop =
            mcsharp_mask_getStop
          | mcsharp_mask_sendStop;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetStopsendStop = new MCSharp.BitMask();

 private void scangetStopsendStop () {
  if ( mcsharpBitMaskgetStopsendStop.match
        ( mcsharp_mask_getStopsendStop ) )
   mcsharpQueuegetStop.wakeup();
 }


[OneWay]
public void mcsharpChannelsendStop (  )  {
   lock ( mcsharpQueuegetStop ) {
    sendStop.Enqueue ( new object [] {  } );
    if ( ! mcsharpBitMaskgetStopsendStop.match
          ( mcsharp_mask_sendStop ) )   {
     mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_sendStop );
     scangetStopsendStop ();
    }
   }
 }

 public void mcsharpHandlergetStop (  )   {
  Monitor.Enter ( mcsharpQueuegetStop );
  if ( ! mcsharpBitMaskgetStopsendStop.match ( mcsharp_mask_getStop ) ) goto now;
  later:
   mcsharpQueuegetStop.yield ( mcsharpQueuegetStop );
   if ( mcsharpQueuegetStop.empty )
    mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_getStop );
  now:
   if ( mcsharpBitMaskgetStopsendStop.match ( 
    mcsharp_mask_sendStop ) )   {
    object[] osendStop = ( object[] ) sendStop.Dequeue();
    if ( sendStop.Count == 0 )
         mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_sendStop );
    scangetStopsendStop ();
    Monitor.Exit ( mcsharpQueuegetStop );
     {
   return ;
  }
   }
   else {
    mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_getStop );
    goto later;
  }

 }
}

[Serializable()]
public  class MSort : ISerializable {

 //-------------- MCsharp functions -----------

 public MSort ( ) {
  mcsharp_initiate();
}

 public MSort ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  sendStop = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendStop" );
  mcsharpQueuegetStop = new MCSharp.ThreadQ();

  getStop = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetStop" );
 }

  private class McsharpPrivateClasssort {

   MSort parent;
   int myNumber;
   int level;
   int m;
   int k;
   int[,] x;
   int P;
   channel  c;

   public McsharpPrivateClasssort ( MSort parent,
               int myNumber,
               int level,
               int m,
               int k,
               int[,] x,
               int P,
               channel  c
              ) {
    this.parent = parent;
    this.myNumber = myNumber;
    this.level = level;
    this.m = m;
    this.k = k;
    this.x = x;
    this.P = P;
    this.c = c;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpsortBody ( myNumber, level, m, k, x, P, c );

   }
  }

  private void mcsharpsortBody (
               int myNumber,
               int level,
               int m,
               int k,
               int[,] x,
               int P,
               channel  c
              )
 {
   if ( myNumber  < P  )
   if ( m + 1  == k   )
   c.Send ( new object[] {   } )
  ;

  else
  {
   int next = 1 - level  ;

  int n = m + ( k - m   ) / 2  ;

  new MSort ( ) .sort( 2 * myNumber   , next   , m   , n   , x   , P   , sendStop   )  ;
 new MSort ( ) .sort( 2 * myNumber   , next   , n   , k   , x   , P   , sendStop   )  ;
 for ( int i = 0  ;

  i  < 2 ; i++   )
 getStop  .Get(new object[]{ } )
;

  merge( next   , m   , n   , k   , x   )  ;
 c.Send ( new object[] {   } )
  ;
 }
 

  else
  {
   local_sort( level   , m   , k   , x   )  ;
 c.Send ( new object[] {   } )
  ;
 }
 
 }




  public  void sort (  int myNumber,  int level,  int m,  int k,  int[,] x,  int P,  channel  c ) {
   McsharpPrivateClasssort prclassobject = new McsharpPrivateClasssort ( this, myNumber, level, m, k, x, P, c );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendStop;

 //-------------Handler declaration-----------------

    public MCSharp.handler getStop;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetStop;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getStop = 1 << 0;
 private const int mcsharp_mask_sendStop = 1 << 1;
 private const int mcsharp_mask_getStopsendStop =
            mcsharp_mask_getStop
          | mcsharp_mask_sendStop;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetStopsendStop = new MCSharp.BitMask();

 private void scangetStopsendStop () {
  if ( mcsharpBitMaskgetStopsendStop.match
        ( mcsharp_mask_getStopsendStop ) )
   mcsharpQueuegetStop.wakeup();
 }


[OneWay]
public void mcsharpChannelsendStop (  )  {
   lock ( mcsharpQueuegetStop ) {
    sendStop.Enqueue ( new object [] {  } );
    if ( ! mcsharpBitMaskgetStopsendStop.match
          ( mcsharp_mask_sendStop ) )   {
     mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_sendStop );
     scangetStopsendStop ();
    }
   }
 }

 public void mcsharpHandlergetStop (  )   {
  Monitor.Enter ( mcsharpQueuegetStop );
  if ( ! mcsharpBitMaskgetStopsendStop.match ( mcsharp_mask_getStop ) ) goto now;
  later:
   mcsharpQueuegetStop.yield ( mcsharpQueuegetStop );
   if ( mcsharpQueuegetStop.empty )
    mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_getStop );
  now:
   if ( mcsharpBitMaskgetStopsendStop.match ( 
    mcsharp_mask_sendStop ) )   {
    object[] osendStop = ( object[] ) sendStop.Dequeue();
    if ( sendStop.Count == 0 )
         mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_sendStop );
    scangetStopsendStop ();
    Monitor.Exit ( mcsharpQueuegetStop );
     {
   return ;
  }
   }
   else {
    mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_getStop );
    goto later;
  }

 }
public  void local_sort (  int level,  int m,  int k,  int[,] x )   {
   int next = 1 - level  ;

  if ( m + 1  == k   )
    {
   if ( level  == 1   )
   x[ 1  , m   ] = x[ 0  , m   ]  ;

  return ;
  }

  int n = m + ( k - m   ) / 2  ;

  local_sort( next   , m   , n   , x   )  ;
 local_sort( next   , n   , k   , x   )  ;
 merge( next   , m   , n   , k   , x   )  ;
 }
public static  void merge (  int from,  int m,  int n,  int k,  int[,] x )   {
   int i , j , position ;

  int to = 1 - from  ;

  i = m  ;
 j = n  ;
 position = m  ;
 while ( position  < k  )
  {
   if ( i  == n   )
   while ( j  < k  )
  {
   x[ to  , position   ] = x[ from  , j   ]  ;
 j++  ;
 position++  ;
 }

 
  else
 if ( j  == k   )
   while ( i  < n  )
  {
   x[ to  , position   ] = x[ from  , i   ]  ;
 i++  ;
 position++  ;
 }

 
  else
  {
   if ( x[ from  , i   ]  < x[ from  , j   ]  )
    {
   x[ to  , position   ] = x[ from  , i   ]  ;
 i++  ;
 }

  else
  {
   x[ to  , position   ] = x[ from  , j   ]  ;
 j++  ;
 }
 
 position++  ;
 }
 
 
 }

  }
}

