using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

[Serializable()]
public  class B : ISerializable {

 //-------------- MCsharp functions -----------

 public B ( ) {
  mcsharp_initiate();
}

 public B ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  c = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelc" );
 }


 //-------------Channel declarations-----------------

  public MCSharp.channel c;

 //-------------Masks--------------------------------

 private const int mcsharp_mask_c = 1 << 0;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskc = new MCSharp.BitMask();

 private void scanc () {
  if ( mcsharpBitMaskc.match
        ( mcsharp_mask_c ) )
  {   Monitor.Enter ( c );
   object[] oc = (object[]) c.Dequeue();
   String s = (String) oc [0];
   if ( c.Count == 0 )
       mcsharpBitMaskc.clear ( mcsharp_mask_c );
   Monitor.Exit ( c );
   McsharpPrivateClassc prclassobject = new McsharpPrivateClassc ( this , s );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
   scanc();
  }
}


[OneWay]
public void mcsharpChannelc (  String s )  {
   lock ( c ) {
    c.Enqueue ( new object [] { s } );
    if ( ! mcsharpBitMaskc.match
          ( mcsharp_mask_c ) )   {
     mcsharpBitMaskc.set ( mcsharp_mask_c );
     scanc ();
    }
   }
 }

  private class McsharpPrivateClassc {

   B parent;
   String s;

   public McsharpPrivateClassc ( B parent,
               String s
              ) {
    this.parent = parent;
    this.s = s;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpcBody ( s );

   }
  }

  private void mcsharpcBody (
               String s
              )
 {
   Console.WriteLine( "Object b Channel c received message : " + s   )  ;
 }


}

[Serializable()]
 class Program : ISerializable {

 //-------------- MCsharp functions -----------

 public Program ( ) {
  mcsharp_initiate();
}

 public Program ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

 }

public static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   Program p = new Program ( )   ;

  B b = new B ( )   ;

  p.m_fun( b   )  ;
 Console.ReadKey( )  ;
 }
  private class McsharpPrivateClassm_fun {

   Program parent;
   B b;

   public McsharpPrivateClassm_fun ( Program parent,
               B b
              ) {
    this.parent = parent;
    this.b = b;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpm_funBody ( b );

   }
  }

  private void mcsharpm_funBody (
               B b
              )
 {
   b.c.Send ( new object[] {  "Hello !"    } )
  ;
 }




  public  void m_fun (  B b ) {
   McsharpPrivateClassm_fun prclassobject = new McsharpPrivateClassm_fun ( this, b );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }
}

