using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

[Serializable()]
public  class B : ISerializable {

 //-------------- MCsharp functions -----------

 public B ( ) {
  mcsharp_initiate();
}

 public B ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  c = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelc" );
  mcsharpQueueh = new MCSharp.ThreadQ();

  h = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlerh" );
 }


 //-------------Channel declarations-----------------

  public MCSharp.channel c;

 //-------------Handler declaration-----------------

    public MCSharp.handler h;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueueh;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_h = 1 << 0;
 private const int mcsharp_mask_c = 1 << 1;
 private const int mcsharp_mask_hc =
            mcsharp_mask_h
          | mcsharp_mask_c;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskhc = new MCSharp.BitMask();

 private void scanhc () {
  if ( mcsharpBitMaskhc.match
        ( mcsharp_mask_hc ) )
   mcsharpQueueh.wakeup();
 }


[OneWay]
public void mcsharpChannelc (  String s )  {
   lock ( mcsharpQueueh ) {
    c.Enqueue ( new object [] { s } );
    if ( ! mcsharpBitMaskhc.match
          ( mcsharp_mask_c ) )   {
     mcsharpBitMaskhc.set ( mcsharp_mask_c );
     scanhc ();
    }
   }
 }

 public String mcsharpHandlerh (  )   {
  Monitor.Enter ( mcsharpQueueh );
  if ( ! mcsharpBitMaskhc.match ( mcsharp_mask_h ) ) goto now;
  later:
   mcsharpQueueh.yield ( mcsharpQueueh );
   if ( mcsharpQueueh.empty )
    mcsharpBitMaskhc.clear ( mcsharp_mask_h );
  now:
   if ( mcsharpBitMaskhc.match ( 
    mcsharp_mask_c ) )   {
    object[] oc = ( object[] ) c.Dequeue();
    String s = ( String ) oc [ 0 ];
    if ( c.Count == 0 )
         mcsharpBitMaskhc.clear ( mcsharp_mask_c );
    scanhc ();
    Monitor.Exit ( mcsharpQueueh );
     {
   return ( s + " and from B !"   )  ;
  }
   }
   else {
    mcsharpBitMaskhc.set ( mcsharp_mask_h );
    goto later;
  }

 }
}

[Serializable()]
 class Program : ISerializable {

 //-------------- MCsharp functions -----------

 public Program ( ) {
  mcsharp_initiate();
}

 public Program ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

 }

public static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   Program p = new Program ( )   ;

  B b = new B ( )   ;

  p.m_fun( b   )  ;
 b.c.Send ( new object[] {  "Hello from root ! "    } )
  ;
 Console.ReadKey( )  ;
 }
  private class McsharpPrivateClassm_fun {

   Program parent;
   B b;

   public McsharpPrivateClassm_fun ( Program parent,
               B b
              ) {
    this.parent = parent;
    this.b = b;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpm_funBody ( b );

   }
  }

  private void mcsharpm_funBody (
               B b
              )
 {
   String s = (String)b.h  .Get(new object[]{ } )
;

  Console.WriteLine( "Async method received the message  '" + s + "' through the handler"   )  ;
 }




  public  void m_fun (  B b ) {
   McsharpPrivateClassm_fun prclassobject = new McsharpPrivateClassm_fun ( this, b );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }
}

