using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

[Serializable()]
public  class PingPong : ISerializable {

 //-------------- MCsharp functions -----------

 public PingPong ( ) {
  mcsharp_initiate();
}

 public PingPong ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  ping = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelping" );
  pong = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelpong" );
 }

int kicks = 4  ;

 
 //-------------Channel declarations-----------------

  public MCSharp.channel ping;

 //-------------Masks--------------------------------

 private const int mcsharp_mask_ping = 1 << 0;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskping = new MCSharp.BitMask();

 private void scanping () {
  if ( mcsharpBitMaskping.match
        ( mcsharp_mask_ping ) )
  {   Monitor.Enter ( ping );
   object[] oping = (object[]) ping.Dequeue();
   if ( ping.Count == 0 )
       mcsharpBitMaskping.clear ( mcsharp_mask_ping );
   Monitor.Exit ( ping );
   McsharpPrivateClassping prclassobject = new McsharpPrivateClassping ( this  );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
   scanping();
  }
}


[OneWay]
public void mcsharpChannelping (  )  {
   lock ( ping ) {
    ping.Enqueue ( new object [] {  } );
    if ( ! mcsharpBitMaskping.match
          ( mcsharp_mask_ping ) )   {
     mcsharpBitMaskping.set ( mcsharp_mask_ping );
     scanping ();
    }
   }
 }

  private class McsharpPrivateClassping {

   PingPong parent;

   public McsharpPrivateClassping ( PingPong parent
              ) {
    this.parent = parent;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharppingBody (  );

   }
  }

  private void mcsharppingBody (

              )
 {
   if ( ( kicks--   )  != 0   )
    {
   Thread.Sleep( 1000   )  ;
 Console.WriteLine( "ping..."   )  ;
 pong.Send ( new object[] {   } )
  ;
 }

  }



 //-------------Channel declarations-----------------

  public MCSharp.channel pong;

 //-------------Masks--------------------------------

 private const int mcsharp_mask_pong = 1 << 0;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskpong = new MCSharp.BitMask();

 private void scanpong () {
  if ( mcsharpBitMaskpong.match
        ( mcsharp_mask_pong ) )
  {   Monitor.Enter ( pong );
   object[] opong = (object[]) pong.Dequeue();
   if ( pong.Count == 0 )
       mcsharpBitMaskpong.clear ( mcsharp_mask_pong );
   Monitor.Exit ( pong );
   McsharpPrivateClasspong prclassobject = new McsharpPrivateClasspong ( this  );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
   scanpong();
  }
}


[OneWay]
public void mcsharpChannelpong (  )  {
   lock ( pong ) {
    pong.Enqueue ( new object [] {  } );
    if ( ! mcsharpBitMaskpong.match
          ( mcsharp_mask_pong ) )   {
     mcsharpBitMaskpong.set ( mcsharp_mask_pong );
     scanpong ();
    }
   }
 }

  private class McsharpPrivateClasspong {

   PingPong parent;

   public McsharpPrivateClasspong ( PingPong parent
              ) {
    this.parent = parent;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharppongBody (  );

   }
  }

  private void mcsharppongBody (

              )
 {
   Thread.Sleep( 1000   )  ;
 Console.WriteLine( "pong..."   )  ;
 ping.Send ( new object[] {   } )
  ;
 }


public static  void Main (  string[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  string[] args )  {
   PingPong pp = new PingPong ( )   ;

  pp.ping.Send ( new object[] {   } )
  ;
 Console.ReadLine( )  ;
 }
}

