using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

[Serializable()]
 class Producer : ISerializable {

 //-------------- MCsharp functions -----------

 public Producer ( ) {
  mcsharp_initiate();
}

 public Producer ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

 }

  private class McsharpPrivateClassproduce {

   Producer parent;
   channel  toConsumer;

   public McsharpPrivateClassproduce ( Producer parent,
               channel  toConsumer
              ) {
    this.parent = parent;
    this.toConsumer = toConsumer;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpproduceBody ( toConsumer );

   }
  }

  private void mcsharpproduceBody (
               channel  toConsumer
              )
 {
   Random rnd = new Random ( )   ;

  for ( int i = 0  ;

  i  < 10 ; i++   )
 toConsumer.Send ( new object[] {  rnd.NextDouble( )    } )
  ;

  }




  public  void produce (  channel  toConsumer ) {
   McsharpPrivateClassproduce prclassobject = new McsharpPrivateClassproduce ( this, toConsumer );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }
}

[Serializable()]
 class Consumer : ISerializable {

 //-------------- MCsharp functions -----------

 public Consumer ( ) {
  mcsharp_initiate();
}

 public Consumer ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  data = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChanneldata" );
  mcsharpQueueGetData = new MCSharp.ThreadQ();

  GetData = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlerGetData" );
 }


 //-------------Channel declarations-----------------

  public MCSharp.channel data;

 //-------------Handler declaration-----------------

    public MCSharp.handler GetData;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueueGetData;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_GetData = 1 << 0;
 private const int mcsharp_mask_data = 1 << 1;
 private const int mcsharp_mask_GetDatadata =
            mcsharp_mask_GetData
          | mcsharp_mask_data;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskGetDatadata = new MCSharp.BitMask();

 private void scanGetDatadata () {
  if ( mcsharpBitMaskGetDatadata.match
        ( mcsharp_mask_GetDatadata ) )
   mcsharpQueueGetData.wakeup();
 }


[OneWay]
public void mcsharpChanneldata (  double x )  {
   lock ( mcsharpQueueGetData ) {
    data.Enqueue ( new object [] { x } );
    if ( ! mcsharpBitMaskGetDatadata.match
          ( mcsharp_mask_data ) )   {
     mcsharpBitMaskGetDatadata.set ( mcsharp_mask_data );
     scanGetDatadata ();
    }
   }
 }

 public double mcsharpHandlerGetData (  )   {
  Monitor.Enter ( mcsharpQueueGetData );
  if ( ! mcsharpBitMaskGetDatadata.match ( mcsharp_mask_GetData ) ) goto now;
  later:
   mcsharpQueueGetData.yield ( mcsharpQueueGetData );
   if ( mcsharpQueueGetData.empty )
    mcsharpBitMaskGetDatadata.clear ( mcsharp_mask_GetData );
  now:
   if ( mcsharpBitMaskGetDatadata.match ( 
    mcsharp_mask_data ) )   {
    object[] odata = ( object[] ) data.Dequeue();
    double x = ( double ) odata [ 0 ];
    if ( data.Count == 0 )
         mcsharpBitMaskGetDatadata.clear ( mcsharp_mask_data );
    scanGetDatadata ();
    Monitor.Exit ( mcsharpQueueGetData );
     {
   return x  ;
  }
   }
   else {
    mcsharpBitMaskGetDatadata.set ( mcsharp_mask_GetData );
    goto later;
  }

 }
  private class McsharpPrivateClassconsume {

   Consumer parent;
   channel  isDone;

   public McsharpPrivateClassconsume ( Consumer parent,
               channel  isDone
              ) {
    this.parent = parent;
    this.isDone = isDone;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpconsumeBody ( isDone );

   }
  }

  private void mcsharpconsumeBody (
               channel  isDone
              )
 {
   for ( int i = 0  ;

  i  < 10 ; i++   )
 Console.WriteLine( i + "  " + (double)GetData  .Get(new object[]{ } )
 )  ;

  isDone.Send ( new object[] {   } )
  ;
 }




  public  void consume (  channel  isDone ) {
   McsharpPrivateClassconsume prclassobject = new McsharpPrivateClassconsume ( this, isDone );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }
}

[Serializable()]
public  class Program : ISerializable {

 //-------------- MCsharp functions -----------

 public Program ( ) {
  mcsharp_initiate();
}

 public Program ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  finish = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelfinish" );
  mcsharpQueueisFinished = new MCSharp.ThreadQ();

  isFinished = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlerisFinished" );
 }


 //-------------Channel declarations-----------------

  public MCSharp.channel finish;

 //-------------Handler declaration-----------------

    public MCSharp.handler isFinished;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueueisFinished;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_isFinished = 1 << 0;
 private const int mcsharp_mask_finish = 1 << 1;
 private const int mcsharp_mask_isFinishedfinish =
            mcsharp_mask_isFinished
          | mcsharp_mask_finish;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskisFinishedfinish = new MCSharp.BitMask();

 private void scanisFinishedfinish () {
  if ( mcsharpBitMaskisFinishedfinish.match
        ( mcsharp_mask_isFinishedfinish ) )
   mcsharpQueueisFinished.wakeup();
 }


[OneWay]
public void mcsharpChannelfinish (  )  {
   lock ( mcsharpQueueisFinished ) {
    finish.Enqueue ( new object [] {  } );
    if ( ! mcsharpBitMaskisFinishedfinish.match
          ( mcsharp_mask_finish ) )   {
     mcsharpBitMaskisFinishedfinish.set ( mcsharp_mask_finish );
     scanisFinishedfinish ();
    }
   }
 }

 public void mcsharpHandlerisFinished (  )   {
  Monitor.Enter ( mcsharpQueueisFinished );
  if ( ! mcsharpBitMaskisFinishedfinish.match ( mcsharp_mask_isFinished ) ) goto now;
  later:
   mcsharpQueueisFinished.yield ( mcsharpQueueisFinished );
   if ( mcsharpQueueisFinished.empty )
    mcsharpBitMaskisFinishedfinish.clear ( mcsharp_mask_isFinished );
  now:
   if ( mcsharpBitMaskisFinishedfinish.match ( 
    mcsharp_mask_finish ) )   {
    object[] ofinish = ( object[] ) finish.Dequeue();
    if ( finish.Count == 0 )
         mcsharpBitMaskisFinishedfinish.clear ( mcsharp_mask_finish );
    scanisFinishedfinish ();
    Monitor.Exit ( mcsharpQueueisFinished );
     {
   return ;
  }
   }
   else {
    mcsharpBitMaskisFinishedfinish.set ( mcsharp_mask_isFinished );
    goto later;
  }

 }
public static  void Main (  string[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  string[] args )  {
   Program program = new Program ( )   ;

  Consumer c = new Consumer ( )   ;

  new Producer ( ) .produce( c.data   )  ;
 c.consume( program.finish   )  ;
 program.isFinished  .Get(new object[]{ } )
;
 Console.WriteLine( "Finished!"   )  ;
 }
}

