using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

[Serializable()]
public  class Fib : ISerializable {

 //-------------- MCsharp functions -----------

 public Fib ( ) {
  mcsharp_initiate();
}

 public Fib ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  c1 = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelc1" );
  c2 = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelc2" );
  mcsharpQueueGet2 = new MCSharp.ThreadQ();

  Get2 = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlerGet2" );
 }


 //-------------Channel declarations-----------------

  public MCSharp.channel c1;
  public MCSharp.channel c2;

 //-------------Handler declaration-----------------

    public MCSharp.handler Get2;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueueGet2;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_Get2 = 1 << 0;
 private const int mcsharp_mask_c1 = 1 << 1;
 private const int mcsharp_mask_c2 = 1 << 2;
 private const int mcsharp_mask_Get2c1c2 =
            mcsharp_mask_Get2
          | mcsharp_mask_c1
          | mcsharp_mask_c2;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskGet2c1c2 = new MCSharp.BitMask();

 private void scanGet2c1c2 () {
  if ( mcsharpBitMaskGet2c1c2.match
        ( mcsharp_mask_Get2c1c2 ) )
   mcsharpQueueGet2.wakeup();
 }


[OneWay]
public void mcsharpChannelc1 (  long x )  {
   lock ( mcsharpQueueGet2 ) {
    c1.Enqueue ( new object [] { x } );
    if ( ! mcsharpBitMaskGet2c1c2.match
          ( mcsharp_mask_c1 ) )   {
     mcsharpBitMaskGet2c1c2.set ( mcsharp_mask_c1 );
     scanGet2c1c2 ();
    }
   }
 }

[OneWay]
public void mcsharpChannelc2 (  long y )  {
   lock ( mcsharpQueueGet2 ) {
    c2.Enqueue ( new object [] { y } );
    if ( ! mcsharpBitMaskGet2c1c2.match
          ( mcsharp_mask_c2 ) )   {
     mcsharpBitMaskGet2c1c2.set ( mcsharp_mask_c2 );
     scanGet2c1c2 ();
    }
   }
 }

 public long mcsharpHandlerGet2 (  )   {
  Monitor.Enter ( mcsharpQueueGet2 );
  if ( ! mcsharpBitMaskGet2c1c2.match ( mcsharp_mask_Get2 ) ) goto now;
  later:
   mcsharpQueueGet2.yield ( mcsharpQueueGet2 );
   if ( mcsharpQueueGet2.empty )
    mcsharpBitMaskGet2c1c2.clear ( mcsharp_mask_Get2 );
  now:
   if ( mcsharpBitMaskGet2c1c2.match ( 
    mcsharp_mask_c1 | mcsharp_mask_c2 ) )   {
    object[] oc1 = ( object[] ) c1.Dequeue();
    long x = ( long ) oc1 [ 0 ];
    if ( c1.Count == 0 )
         mcsharpBitMaskGet2c1c2.clear ( mcsharp_mask_c1 );
    object[] oc2 = ( object[] ) c2.Dequeue();
    long y = ( long ) oc2 [ 0 ];
    if ( c2.Count == 0 )
         mcsharpBitMaskGet2c1c2.clear ( mcsharp_mask_c2 );
    scanGet2c1c2 ();
    Monitor.Exit ( mcsharpQueueGet2 );
     {
   return x + y  ;
  }
   }
   else {
    mcsharpBitMaskGet2c1c2.set ( mcsharp_mask_Get2 );
    goto later;
  }

 }
 public void Compute (  long n,  channel  c )  {
   MCSharp.TCP.DeliverMovableMethod ( this,"Compute_Body_MCSharpWrapper", new object[] {n, c} );
 }

 public void Compute_Body_MCSharpWrapper (  long n,  channel  c )  {
   if ( n  <= 1  )
   c.Send ( new object[] {  n    } )
  ;

  else
  {
   new Fib ( ) .Compute( n - 1   , c1   )  ;
 new Fib ( ) .Compute( n - 2   , c2   )  ;
 c.Send ( new object[] {  (long)Get2  .Get(new object[]{ } )
  } )
  ;
 }
 
 }
}

[Serializable()]
public  class ComputeFib : ISerializable {

 //-------------- MCsharp functions -----------

 public ComputeFib ( ) {
  mcsharp_initiate();
}

 public ComputeFib ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  c = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelc" );
  mcsharpQueueGet = new MCSharp.ThreadQ();

  Get = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlerGet" );
 }


 //-------------Channel declarations-----------------

  public MCSharp.channel c;

 //-------------Handler declaration-----------------

    public MCSharp.handler Get;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueueGet;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_Get = 1 << 0;
 private const int mcsharp_mask_c = 1 << 1;
 private const int mcsharp_mask_Getc =
            mcsharp_mask_Get
          | mcsharp_mask_c;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskGetc = new MCSharp.BitMask();

 private void scanGetc () {
  if ( mcsharpBitMaskGetc.match
        ( mcsharp_mask_Getc ) )
   mcsharpQueueGet.wakeup();
 }


[OneWay]
public void mcsharpChannelc (  long x )  {
   lock ( mcsharpQueueGet ) {
    c.Enqueue ( new object [] { x } );
    if ( ! mcsharpBitMaskGetc.match
          ( mcsharp_mask_c ) )   {
     mcsharpBitMaskGetc.set ( mcsharp_mask_c );
     scanGetc ();
    }
   }
 }

 public long mcsharpHandlerGet (  )   {
  Monitor.Enter ( mcsharpQueueGet );
  if ( ! mcsharpBitMaskGetc.match ( mcsharp_mask_Get ) ) goto now;
  later:
   mcsharpQueueGet.yield ( mcsharpQueueGet );
   if ( mcsharpQueueGet.empty )
    mcsharpBitMaskGetc.clear ( mcsharp_mask_Get );
  now:
   if ( mcsharpBitMaskGetc.match ( 
    mcsharp_mask_c ) )   {
    object[] oc = ( object[] ) c.Dequeue();
    long x = ( long ) oc [ 0 ];
    if ( c.Count == 0 )
         mcsharpBitMaskGetc.clear ( mcsharp_mask_c );
    scanGetc ();
    Monitor.Exit ( mcsharpQueueGet );
     {
   return x  ;
  }
   }
   else {
    mcsharpBitMaskGetc.set ( mcsharp_mask_Get );
    goto later;
  }

 }
public static  void Main (  string[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  string[] args )  {
   if ( args.Length  < 1  )
    {
   Console.WriteLine( "Usage: Fib.exe <number>"   )  ;
 return ;
  }

  int n = System.Convert.ToInt32( args[ 0   ]   )  ;

  ComputeFib cf = new ComputeFib ( )   ;

  Fib fib = new Fib ( )   ;

  fib.Compute( n   , cf.c   )  ;
 Console.WriteLine( "For n = " + n + " value is " + cf.Get  .Get(new object[]{ } )
 )  ;
 }
}

