using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

using GpuDotNet.Cuda;
[Serializable()]
public static  class VectorAddition {

public static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   int N = Convert.ToInt32( args[ 0   ]   )  ;

  Console.WriteLine( "N = " + N   )  ;
 int[] A = new int [ N   ]    ;

  int[] B = new int [ N   ]    ;

  int[] C = new int [ N   ]    ;

  for ( int i = 0  ;

  i  < N ; i++   )
  {
   A[ i   ] = i  ;
 B[ i   ] = i + 1  ;
 }

  GpuConfig gpuconfig = new GpuConfig ( )   ;

  gpuconfig.SetBlockSize( N   )  ;
 gpuconfig.vecadd( A   , B   , C   )  ;
 for ( int i = 0  ;

  i  < N ; i++   )
 Console.WriteLine( C[ i   ]   )  ;

  }
 public delegate void _VectorAddition_vecadd_delegate (  int[] A,  int[] B,  int[] C ) ;

 public static void vecadd ( this GpuConfig gpuconfig,   int[] A,  int[] B,  int[] C )  
 {
  _VectorAddition_vecadd_delegate gpu_method_delegate = _VectorAddition_gpu_vecadd;
  GpuRuntime.PrepareAndCallGpuMethod ( gpuconfig, gpu_method_delegate, A, B, C );
 }

 public static void _VectorAddition_gpu_vecadd (  int[] A,  int[] B,  int[] C ) 
 {
   int i = ThreadIndex.X  ;

  C[ i   ] = A[ i   ] + B[ i   ]  ;
 }

}

