#ifndef DEF_CELL
#include "celldef.h"
#define DEF_CELL
#endif

typedef struct listNode{
	Cell data;
	struct listNode *next;
} ListNode;

typedef struct list {
	int count;
	ListNode *entry;
} List;

void CreateList(List *);
void ClearList(List *);
BOOL ListEmpty(const List *);
BOOL ListFull(const List *);
int ListSize(const List *);
void AddList(Cell, List *); 
void TraverseList(List *, void (*)(Cell));
void CopyList(List *, const List *);


