using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

[Serializable()]
public  class PerfectNumbers : ISerializable {

 //-------------- MCsharp functions -----------

 public PerfectNumbers ( ) {
  mcsharp_initiate();
}

 public PerfectNumbers ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

 }

public static  int M = 5000  ;

 public static  bool contin = true  ;

 public static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   int i ;

  Oyster.Math.IntX zero = new Oyster.Math.IntX ( 0   )   ;

  if ( args.Length  < 2  )
    {
   Console.WriteLine( "Usage: PerfectNumbers.exe <Number of the perfect numbers> <Number of threads/cores>"   )  ;
 return ;
  }

  int N = System.Convert.ToInt32( args[ 0   ]   )  ;

  int P = System.Convert.ToInt32( args[ 1   ]   )  ;

  PerfectNumbers pfnums = new PerfectNumbers ( )   ;

  Oyster.Math.IntX[] perf_numbers = new Oyster.Math.IntX [ M   ]    ;

  for ( i = 0  ; i  < M ; i++   )
 perf_numbers[ i   ] = zero  ;

  perf_numbers[ 2   ] = new Oyster.Math.IntX ( 6   )   ;
 Console.WriteLine( perf_numbers[ 2   ] + "\n"   )  ;
 for ( i = 0  ; i  < P ; i++   )
 pfnums.Worker( i   , P   , perf_numbers   )  ;

  int computed_numbers = 1  ;

  int current_q = 2  ;

  while ( computed_numbers  < N  )
  {
   while ( perf_numbers[ current_q + 1   ]  == 0   )
 Thread.Sleep( 10   )  ;

  current_q++  ;
 if ( perf_numbers[ current_q   ]  > 0  )
    {
   Console.WriteLine( perf_numbers[ current_q   ] + "\n"   )  ;
 computed_numbers++  ;
 }

  }

  contin = false  ;
 }
  private class McsharpPrivateClassWorker {

   PerfectNumbers parent;
   int ownNumber;
   int P;
   Oyster.Math.IntX[] perf_numbers;

   public McsharpPrivateClassWorker ( PerfectNumbers parent,
               int ownNumber,
               int P,
               Oyster.Math.IntX[] perf_numbers
              ) {
    this.parent = parent;
    this.ownNumber = ownNumber;
    this.P = P;
    this.perf_numbers = perf_numbers;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpWorkerBody ( ownNumber, P, perf_numbers );

   }
  }

  private void mcsharpWorkerBody (
               int ownNumber,
               int P,
               Oyster.Math.IntX[] perf_numbers
              )
 {
   int j , q ;

  Oyster.Math.IntX L , temp , n ;

  Oyster.Math.IntX m1 = new Oyster.Math.IntX ( -1   )   ;

  q = 3 + ownNumber  ;
 temp = new Oyster.Math.IntX ( 2   )   ;
 for ( j = 1  ; j  < q - 1 ; j++   )
 temp = temp * 2  ;

  n = temp * 2 - 1  ;
 while ( contin   )
  {
   j = 0  ;
 L = new Oyster.Math.IntX ( 4   )   ;
 for ( j = 1  ; j  < q - 1 ; j++   )
 if ( contin   )
   L = ( L * L - 2   ) % n  ;

 
  if ( !contin   )
   break  ;

  if ( L  == 0   )
   perf_numbers[ q   ] = temp * n  ;

  else
 perf_numbers[ q   ] = m1  ;
 
 j = q - 1  ;
 q = q + P  ;
 while ( j  < q - 1  )
  {
   temp = temp * 2  ;
 j++  ;
 }

  n = temp * 2 - 1  ;
 }

  }




  public  void Worker (  int ownNumber,  int P,  Oyster.Math.IntX[] perf_numbers ) {
   McsharpPrivateClassWorker prclassobject = new McsharpPrivateClassWorker ( this, ownNumber, P, perf_numbers );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }
}

