using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

using System.Drawing;
using System.Collections;
using System.Windows.Forms;
[Serializable()]
 class Form1:Form, ISerializable {

 //-------------- MCsharp functions -----------

 public Form1 ( ) {
  mcsharp_initiate();
}

 public Form1 ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  AddNewFragment = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelAddNewFragment" );
 }

Bitmap[] fragments ;

 bool[] IsRenderedpics ;

 int renderedfrags = 0  ;

 int totalNumberOfLines ;

 public  Form1 (  string[] args )  {

   mcsharp_initiate();

    this .DoubleBuffered = true  ;
 this .AutoScroll = true  ;
 this .ClientSize = new Size ( Convert.ToInt32( args[ 5   ]   ) + 10   , Convert.ToInt32( args[ 6   ]   ) + 10   )   ;
 this .DockPadding.All = Convert.ToInt32( args[ 5   ]   ) + 10  ;
 this .SizeGripStyle = SizeGripStyle.Show  ;
 this .Name = "Mandelbrot set demo"  ;
 this .Text = "Mandelbrot set demo"  ;
 this .TransparencyKey = Color.Green  ;
 Label l = new Label ( )   ;

  l.Size = new Size ( 0   , 0   )   ;
 this .Controls.AddRange( new Control[] { l     }      )  ;
 this .Paint += new PaintEventHandler ( this .Form1_Paint   )   ;
 double x1 = Convert.ToDouble( args[ 0   ]   )  ;

  double y1 = Convert.ToDouble( args[ 1   ]   )  ;

  double x2 = Convert.ToDouble( args[ 2   ]   )  ;

  double y2 = Convert.ToDouble( args[ 3   ]   )  ;

  totalNumberOfLines = Convert.ToInt32( args[ 4   ]   )  ;
 int cx = System.Convert.ToInt32( args[ 5   ]   )  ;

  int cy = (int)( System.Convert.ToInt32( args[ 6   ]   ) / totalNumberOfLines   ) + 1  ;

  double deltaY = (double)( ( y2 - y1   ) / totalNumberOfLines   )  ;

  fragments = new Bitmap [ totalNumberOfLines   ]    ;
 IsRenderedpics = new bool [ totalNumberOfLines   ]    ;
 for ( int i = 0  ;

  i  < totalNumberOfLines ; i++   )
  {
   Division( x1   , y1 + deltaY * i   , x2   , y1 + deltaY * ( i + 1   )   , cx   , cy   , i   , AddNewFragment   )  ;
 }

 

 }

  private class McsharpPrivateClassDivision {

   Form1 parent;
   double x1;
   double y1;
   double x2;
   double y2;
   int cx;
   int cy;
   int numberOfFragment;
   channel  Channel;

   public McsharpPrivateClassDivision ( Form1 parent,
               double x1,
               double y1,
               double x2,
               double y2,
               int cx,
               int cy,
               int numberOfFragment,
               channel  Channel
              ) {
    this.parent = parent;
    this.x1 = x1;
    this.y1 = y1;
    this.x2 = x2;
    this.y2 = y2;
    this.cx = cx;
    this.cy = cy;
    this.numberOfFragment = numberOfFragment;
    this.Channel = Channel;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpDivisionBody ( x1, y1, x2, y2, cx, cy, numberOfFragment, Channel );

   }
  }

  private void mcsharpDivisionBody (
               double x1,
               double y1,
               double x2,
               double y2,
               int cx,
               int cy,
               int numberOfFragment,
               channel  Channel
              )
 {
   Channel.Send ( new object[] {  InternalCalculate( x1   , y1   , x2   , y2   , cx   , cy   , numberOfFragment   )   , numberOfFragment    } )
  ;
 }




   void Division (  double x1,  double y1,  double x2,  double y2,  int cx,  int cy,  int numberOfFragment,  channel  Channel ) {
   McsharpPrivateClassDivision prclassobject = new McsharpPrivateClassDivision ( this, x1, y1, x2, y2, cx, cy, numberOfFragment, Channel );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }

 //-------------Channel declarations-----------------

  public MCSharp.channel AddNewFragment;

 //-------------Masks--------------------------------

 private const int mcsharp_mask_AddNewFragment = 1 << 0;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskAddNewFragment = new MCSharp.BitMask();

 private void scanAddNewFragment () {
  if ( mcsharpBitMaskAddNewFragment.match
        ( mcsharp_mask_AddNewFragment ) )
  {   Monitor.Enter ( AddNewFragment );
   object[] oAddNewFragment = (object[]) AddNewFragment.Dequeue();
   Bitmap part = (Bitmap) oAddNewFragment [0];
   int numberOfFragment = (int) oAddNewFragment [1];
   if ( AddNewFragment.Count == 0 )
       mcsharpBitMaskAddNewFragment.clear ( mcsharp_mask_AddNewFragment );
   Monitor.Exit ( AddNewFragment );
   McsharpPrivateClassAddNewFragment prclassobject = new McsharpPrivateClassAddNewFragment ( this , part, numberOfFragment );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
   scanAddNewFragment();
  }
}


[OneWay]
public void mcsharpChannelAddNewFragment (  Bitmap part,  int numberOfFragment )  {
   lock ( AddNewFragment ) {
    AddNewFragment.Enqueue ( new object [] { part, numberOfFragment } );
    if ( ! mcsharpBitMaskAddNewFragment.match
          ( mcsharp_mask_AddNewFragment ) )   {
     mcsharpBitMaskAddNewFragment.set ( mcsharp_mask_AddNewFragment );
     scanAddNewFragment ();
    }
   }
 }

  private class McsharpPrivateClassAddNewFragment {

   Form1 parent;
   Bitmap part;
   int numberOfFragment;

   public McsharpPrivateClassAddNewFragment ( Form1 parent,
               Bitmap part,
               int numberOfFragment
              ) {
    this.parent = parent;
    this.part = part;
    this.numberOfFragment = numberOfFragment;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpAddNewFragmentBody ( part, numberOfFragment );

   }
  }

  private void mcsharpAddNewFragmentBody (
               Bitmap part,
               int numberOfFragment
              )
 {
   lock ( this    )  {
   fragments[ numberOfFragment   ] = part  ;
 }
 Rectangle r = new Rectangle ( this .AutoScrollPosition.X   , ( numberOfFragment   ) * ( fragments[ numberOfFragment   ]   ).Height + this .AutoScrollPosition.Y   , part.Width   , part.Height   )   ;

  this .Invalidate( r   )  ;
 }


private  void Form1_Paint (  object sender,  PaintEventArgs e )   {
   lock ( this    )  {
   if ( renderedfrags  != totalNumberOfLines   )
    {
   for ( int i = 0  ;

  i  < fragments.Length ; i++   )
  {
   if ( ( IsRenderedpics[ i   ]  == false   )  && ( fragments[ i   ]  != null   )   )
    {
   e.Graphics.DrawImage( fragments[ i   ]   , this .AutoScrollPosition.X   , i * fragments[ i   ].Height + this .AutoScrollPosition.Y   )  ;
 e.Graphics.DrawString( i.ToString( )   , new Font ( "Times New Roman"   , 14   )    , new SolidBrush ( Color.Black   )    , new PointF ( this .AutoScrollPosition.X   , i * fragments[ i   ].Height + this .AutoScrollPosition.Y   )    )  ;
 IsRenderedpics[ i   ] = true  ;
 renderedfrags++  ;
 }

  }

  }

  else
  {
   for ( int i = 0  ;

  i  < fragments.Length ; i++   )
  {
   e.Graphics.DrawImage( fragments[ i   ]   , this .AutoScrollPosition.X   , i * fragments[ i   ].Height + this .AutoScrollPosition.Y   )  ;
 e.Graphics.DrawString( i.ToString( )   , new Font ( "Times New Roman"   , 14   )    , new SolidBrush ( Color.Black   )    , new PointF ( this .AutoScrollPosition.X   , i * fragments[ i   ].Height + this .AutoScrollPosition.Y   )    )  ;
 }

  }
 
 }
 }
private  Bitmap InternalCalculate (  double x1,  double y1,  double x2,  double y2,  int cx,  int cy,  int numberOfPiece )   {
   const  int m_iLimit = 255  ;

  double dAddx = ( x2 - x1   ) / ( (double)cx   )  ;

  double dAddy = ( y2 - y1   ) / ( (double)cy   )  ;

  Bitmap outBmp = new Bitmap ( cx   , cy   )   ;

  for ( int i = 0  ;

  i  < cy ; i++   )
  {
   double dCr = x1  ;

  for ( int j = 0  ;

  j  < cx ; j++   )
  {
   int c = 0  ;

  double dZr = 0.0  , dZi = 0.0  , dZiSqr = 0.0  , dZrSqr = 0.0  , dZr1 ;

  while ( c  < m_iLimit && dZiSqr + dZrSqr  < 4  )
  {
   dZr1 = dZrSqr - dZiSqr + dCr  ;
 dZi = 2 * dZr * dZi + y1  ;
 dZr = dZr1  ;
 dZiSqr = dZi * dZi  ;
 dZrSqr = dZr * dZr  ;
 ++c  ;
 }

  if ( c  >= m_iLimit  )
   outBmp.SetPixel( j   , i   , GetColor( 0   )   )  ;

  else
 outBmp.SetPixel( j   , i   , GetColor( c   )   )  ;
 
 dCr += dAddx  ;
 }

  y1 += dAddy  ;
 }

  return outBmp  ;
  }
private  Color GetColor (  int code )   {
   return colors[ code % 45   ]  ;
  }
Color[] colors = { Color.Black  , Color.AntiqueWhite  , Color.Aqua  , Color.Aquamarine  , Color.Azure  , Color.Beige  , Color.Bisque  , Color.Black  , Color.BlanchedAlmond  , Color.Blue  , Color.BlueViolet  , Color.Brown  , Color.BurlyWood  , Color.CadetBlue  , Color.Chartreuse  , Color.Chocolate  , Color.Coral  , Color.CornflowerBlue  , Color.Cornsilk  , Color.Crimson  , Color.Cyan  , Color.DarkBlue  , Color.DarkCyan  , Color.DarkGoldenrod  , Color.DarkGray  , Color.DarkGreen  , Color.DarkKhaki  , Color.DarkMagenta  , Color.DarkOliveGreen  , Color.DarkOrange  , Color.DarkOrchid  , Color.DarkRed  , Color.DarkSalmon  , Color.DarkSeaGreen  , Color.DarkSlateBlue  , Color.DarkSlateGray  , Color.DarkTurquoise  , Color.DarkViolet  , Color.DeepPink  , Color.DeepSkyBlue  , Color.DimGray  , Color.DodgerBlue  , Color.DodgerBlue  , Color.Firebrick  , Color.FloralWhite   };

 }

