using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

[Serializable()]
public  class Pong : ISerializable {

 //-------------- MCsharp functions -----------

 public Pong ( ) {
  mcsharp_initiate();
}

 public Pong ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  toPong = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChanneltoPong" );
  mcsharpQueuegetPong = new MCSharp.ThreadQ();

  getPong = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetPong" );
 }


 //-------------Channel declarations-----------------

  public MCSharp.channel toPong;

 //-------------Handler declaration-----------------

    public MCSharp.handler getPong;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetPong;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getPong = 1 << 0;
 private const int mcsharp_mask_toPong = 1 << 1;
 private const int mcsharp_mask_getPongtoPong =
            mcsharp_mask_getPong
          | mcsharp_mask_toPong;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetPongtoPong = new MCSharp.BitMask();

 private void scangetPongtoPong () {
  if ( mcsharpBitMaskgetPongtoPong.match
        ( mcsharp_mask_getPongtoPong ) )
   mcsharpQueuegetPong.wakeup();
 }


[OneWay]
public void mcsharpChanneltoPong (  string m )  {
   lock ( mcsharpQueuegetPong ) {
    toPong.Enqueue ( new object [] { m } );
    if ( ! mcsharpBitMaskgetPongtoPong.match
          ( mcsharp_mask_toPong ) )   {
     mcsharpBitMaskgetPongtoPong.set ( mcsharp_mask_toPong );
     scangetPongtoPong ();
    }
   }
 }

 public string mcsharpHandlergetPong (  )   {
  Monitor.Enter ( mcsharpQueuegetPong );
  if ( ! mcsharpBitMaskgetPongtoPong.match ( mcsharp_mask_getPong ) ) goto now;
  later:
   mcsharpQueuegetPong.yield ( mcsharpQueuegetPong );
   if ( mcsharpQueuegetPong.empty )
    mcsharpBitMaskgetPongtoPong.clear ( mcsharp_mask_getPong );
  now:
   if ( mcsharpBitMaskgetPongtoPong.match ( 
    mcsharp_mask_toPong ) )   {
    object[] otoPong = ( object[] ) toPong.Dequeue();
    string m = ( string ) otoPong [ 0 ];
    if ( toPong.Count == 0 )
         mcsharpBitMaskgetPongtoPong.clear ( mcsharp_mask_toPong );
    scangetPongtoPong ();
    Monitor.Exit ( mcsharpQueuegetPong );
     {
   return m  ;
  }
   }
   else {
    mcsharpBitMaskgetPongtoPong.set ( mcsharp_mask_getPong );
    goto later;
  }

 }
  private class McsharpPrivateClasspong {

   Pong parent;
   handler  getPing;
   channel  toPing;

   public McsharpPrivateClasspong ( Pong parent,
               handler  getPing,
               channel  toPing
              ) {
    this.parent = parent;
    this.getPing = getPing;
    this.toPing = toPing;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharppongBody ( getPing, toPing );

   }
  }

  private void mcsharppongBody (
               handler  getPing,
               channel  toPing
              )
 {
   for ( int i = 0  ;

  i  < 4 ; i++   )
  {
   toPing.Send ( new object[] {  "ping..."    } )
  ;
 Console.WriteLine( getPong  .Get(new object[]{ } )
 )  ;
 Thread.Sleep( 1000   )  ;
 }

  }




  public  void pong (  handler  getPing,  channel  toPing ) {
   McsharpPrivateClasspong prclassobject = new McsharpPrivateClasspong ( this, getPing, toPing );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }
}

[Serializable()]
public  class Ping : ISerializable {

 //-------------- MCsharp functions -----------

 public Ping ( ) {
  mcsharp_initiate();
}

 public Ping ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  toPing = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChanneltoPing" );
  mcsharpQueuegetPing = new MCSharp.ThreadQ();

  getPing = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetPing" );
 }


 //-------------Channel declarations-----------------

  public MCSharp.channel toPing;

 //-------------Handler declaration-----------------

    public MCSharp.handler getPing;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetPing;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getPing = 1 << 0;
 private const int mcsharp_mask_toPing = 1 << 1;
 private const int mcsharp_mask_getPingtoPing =
            mcsharp_mask_getPing
          | mcsharp_mask_toPing;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetPingtoPing = new MCSharp.BitMask();

 private void scangetPingtoPing () {
  if ( mcsharpBitMaskgetPingtoPing.match
        ( mcsharp_mask_getPingtoPing ) )
   mcsharpQueuegetPing.wakeup();
 }


[OneWay]
public void mcsharpChanneltoPing (  string m )  {
   lock ( mcsharpQueuegetPing ) {
    toPing.Enqueue ( new object [] { m } );
    if ( ! mcsharpBitMaskgetPingtoPing.match
          ( mcsharp_mask_toPing ) )   {
     mcsharpBitMaskgetPingtoPing.set ( mcsharp_mask_toPing );
     scangetPingtoPing ();
    }
   }
 }

 public string mcsharpHandlergetPing (  )   {
  Monitor.Enter ( mcsharpQueuegetPing );
  if ( ! mcsharpBitMaskgetPingtoPing.match ( mcsharp_mask_getPing ) ) goto now;
  later:
   mcsharpQueuegetPing.yield ( mcsharpQueuegetPing );
   if ( mcsharpQueuegetPing.empty )
    mcsharpBitMaskgetPingtoPing.clear ( mcsharp_mask_getPing );
  now:
   if ( mcsharpBitMaskgetPingtoPing.match ( 
    mcsharp_mask_toPing ) )   {
    object[] otoPing = ( object[] ) toPing.Dequeue();
    string m = ( string ) otoPing [ 0 ];
    if ( toPing.Count == 0 )
         mcsharpBitMaskgetPingtoPing.clear ( mcsharp_mask_toPing );
    scangetPingtoPing ();
    Monitor.Exit ( mcsharpQueuegetPing );
     {
   return m  ;
  }
   }
   else {
    mcsharpBitMaskgetPingtoPing.set ( mcsharp_mask_getPing );
    goto later;
  }

 }
  private class McsharpPrivateClassping {

   Ping parent;
   handler  getPong;
   channel  toPong;

   public McsharpPrivateClassping ( Ping parent,
               handler  getPong,
               channel  toPong
              ) {
    this.parent = parent;
    this.getPong = getPong;
    this.toPong = toPong;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharppingBody ( getPong, toPong );

   }
  }

  private void mcsharppingBody (
               handler  getPong,
               channel  toPong
              )
 {
   for ( int i = 0  ;

  i  < 4 ; i++   )
  {
   Console.WriteLine( getPing  .Get(new object[]{ } )
 )  ;
 Thread.Sleep( 1000   )  ;
 toPong.Send ( new object[] {  "pong..."    } )
  ;
 }

  }




  public  void ping (  handler  getPong,  channel  toPong ) {
   McsharpPrivateClassping prclassobject = new McsharpPrivateClassping ( this, getPong, toPong );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }
}

[Serializable()]
public  class PingPong : ISerializable {

 //-------------- MCsharp functions -----------

 public PingPong ( ) {
  mcsharp_initiate();
}

 public PingPong ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

 }

public static  void Main (  string[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  string[] args )  {
   PingPong pp = new PingPong ( )   ;

  Pong pong = new Pong ( )   ;

  Ping ping = new Ping ( )   ;

  pong.pong( ping.getPing   , ping.toPing   )  ;
 ping.ping( pong.getPong   , pong.toPong   )  ;
 Console.ReadLine( )  ;
 }
}

