using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

using System.Text;
namespace   Sieve_tbb
{
[Serializable()]
public  class Program : ISerializable {

 //-------------- MCsharp functions -----------

 public Program ( ) {
  mcsharp_initiate();
}

 public Program ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  sendResult = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendResult" );
  mcsharpQueueGet = new MCSharp.ThreadQ();

  Get = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlerGet" );
 }

static  bool PrintPrimes ;

 [Serializable()]
 class Multiples : ISerializable {

 //-------------- MCsharp functions -----------

 public Multiples ( ) {
  mcsharp_initiate();
}

 public Multiples ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

 }

private  bool[] my_is_composite ;

 private  int[] my_factor ;

 private  int[] my_striker ;

 public  int n_factor ;

 public  int m ;

 public  Multiples (  int n )  {

   mcsharp_initiate();

    m = (int)Math.Sqrt( n   )  ;
 m += m  & 1  ;
 my_is_composite = new bool [ m / 2   ]    ;
 my_striker = new int [ m / 2   ]    ;
 my_factor = new int [ m / 2   ]    ;
 n_factor = 0  ;
 for ( int i = 0  ;

  i  < m / 2 ; i++   )
 my_is_composite[ i   ] = false  ;

  for ( int i = 3  ;

  i  < m ; i += 2   )
  {
   if ( !my_is_composite[ i / 2   ]   )
    {
   if ( PrintPrimes   )
   Console.WriteLine( (int)i   )  ;

  my_striker[ n_factor   ] = strike( i / 2   , m / 2   , i   )  ;
 my_factor[ n_factor++   ] = i  ;
 }

  }

 

 }

 int strike (  int start,  int limit,  int stride )   {
   if ( stride  >= 2  )
   for ( ; start  < limit ; start += stride   )
 my_is_composite[ start   ] = true  ;

 
  return start  ;
  }
public  int find_primes_in_window (  int start,  int window_size )   {
   for ( int i = 0  ;

  i  < m / 2 ; i++   )
 my_is_composite[ i   ] = false  ;

  for ( uint k = 0  ;

  k  < n_factor ; ++k   )
 my_striker[ k   ] = strike( my_striker[ k   ] - m / 2   , window_size / 2   , my_factor[ k   ]   )  ;

  int count = 0  ;

  for ( int k = 0  ;

  k  < window_size / 2 ; ++k   )
  {
   if ( !my_is_composite[ k   ]   )
    {
   if ( PrintPrimes   )
   Console.WriteLine( start + 2 * k + 1   )  ;

  ++count  ;
 }

  }

  return count  ;
  }
public  void initialize (  int start )   {
   if ( start  >= 1  )
    {
   my_is_composite = new bool [ m / 2   ]    ;
 my_striker = new int [ m / 2   ]    ;
 for ( uint k = 0  ;

  k  < n_factor ; ++k   )
  {
   int f = my_factor[ k   ]  ;

  int p = ( start - 1   ) / f * f % m  ;

  my_striker[ k   ] = ( Convert.ToBoolean( p  & 1   )   ? p + 2 * f   : p + f    ) / 2  ;
 if ( !( m / 2  <= my_striker[ k   ]  )   )
   return ;
 
  }

  }

  }
}

[Serializable()]
 class Sieve : ISerializable {

 //-------------- MCsharp functions -----------

 public Sieve ( ) {
  mcsharp_initiate();
}

 public Sieve ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

 }

public  Multiples multiples ;

 public  Sieve (  int n )  {

   mcsharp_initiate();

    multiples = new Multiples ( n   )   ;


 }

 int calc (  int start,  int window_size,  int n )   {
   multiples.initialize( start   )  ;
 int tt = window_size  ;

  if ( start + window_size  > n  )
   tt = n - start  ;

  return multiples.find_primes_in_window( start   , tt   )  ;
  }
  private class McsharpPrivateClassSuperCalc {

   Sieve parent;
   int window_size;
   int start;
   int fin;
   int n;
   channel  sendCountPrimes;

   public McsharpPrivateClassSuperCalc ( Sieve parent,
               int window_size,
               int start,
               int fin,
               int n,
               channel  sendCountPrimes
              ) {
    this.parent = parent;
    this.window_size = window_size;
    this.start = start;
    this.fin = fin;
    this.n = n;
    this.sendCountPrimes = sendCountPrimes;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpSuperCalcBody ( window_size, start, fin, n, sendCountPrimes );

   }
  }

  private void mcsharpSuperCalcBody (
               int window_size,
               int start,
               int fin,
               int n,
               channel  sendCountPrimes
              )
 {
   int count_primes = 0  ;

  for ( int j = start  ;

  j  < fin ; j += window_size   )
  {
   bool temp = PrintPrimes  ;

  PrintPrimes = false  ;
 Sieve s1 = new Sieve ( n   )   ;

  PrintPrimes = temp  ;
 if ( j % s1.multiples.m  == 0   )
   count_primes += s1.calc( j   , window_size   , n   )  ;

  }

  sendCountPrimes.Send ( new object[] {  count_primes    } )
  ;
 }




  public  void SuperCalc (  int window_size,  int start,  int fin,  int n,  channel  sendCountPrimes ) {
   McsharpPrivateClassSuperCalc prclassobject = new McsharpPrivateClassSuperCalc ( this, window_size, start, fin, n, sendCountPrimes );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }
}

public static  void ParallelCountPrimes (  int n,  int p )   {
   Program pp = new Program ( )   ;

  totalCountPrimes++  ;
 if ( n  >= 3  )
    {
   Sieve s = new Sieve ( n   )   ;

  int window_size = s.multiples.m  ;

  totalCountPrimes = totalCountPrimes + s.multiples.n_factor  ;
 if ( p  > window_size  )
    {
   Console.WriteLine( "Warning: Threads number (" + p + ") can't be greate then Window Size (" + window_size + ");"   )  ;
 p = window_size  ;
 Console.WriteLine( "Warning: Threads number set to " + window_size + ";"   )  ;
 }

  int count_wind = (int)( n / window_size   )  ;

  for ( int i = 0  ;

  i  < p ; i++   )
  {
   int start ;

  int fin ;

  int cc ;

  int count_wind_p = (int)( count_wind / p   )  ;

  cc = count_wind_p * window_size  ;
 if ( i  == 0   )
    {
   start = window_size  ;
 cc -= window_size  ;
 }

  else
 start = count_wind_p * window_size  ;
 
 if ( i  == ( p - 1   )   )
    {
   fin = n  ;
 cc += ( n - count_wind * window_size   )  ;
 }

  else
  {
   fin = start + ( count_wind_p - 1   ) * window_size  ;
 }
 
 s.SuperCalc( window_size   , start   , fin   , n   , pp.sendResult   )  ;
 }

  for ( int i = 0  ;

  i  < p ; i++   )
 pp.Get  .Get(new object[]{ } )
;

  }

  }
static  int totalCountPrimes = 0  ;

 
 //-------------Channel declarations-----------------

  public MCSharp.channel sendResult;

 //-------------Handler declaration-----------------

    public MCSharp.handler Get;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueueGet;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_Get = 1 << 0;
 private const int mcsharp_mask_sendResult = 1 << 1;
 private const int mcsharp_mask_GetsendResult =
            mcsharp_mask_Get
          | mcsharp_mask_sendResult;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskGetsendResult = new MCSharp.BitMask();

 private void scanGetsendResult () {
  if ( mcsharpBitMaskGetsendResult.match
        ( mcsharp_mask_GetsendResult ) )
   mcsharpQueueGet.wakeup();
 }


[OneWay]
public void mcsharpChannelsendResult (  int countPrimes )  {
   lock ( mcsharpQueueGet ) {
    sendResult.Enqueue ( new object [] { countPrimes } );
    if ( ! mcsharpBitMaskGetsendResult.match
          ( mcsharp_mask_sendResult ) )   {
     mcsharpBitMaskGetsendResult.set ( mcsharp_mask_sendResult );
     scanGetsendResult ();
    }
   }
 }

 public int mcsharpHandlerGet (  )   {
  Monitor.Enter ( mcsharpQueueGet );
  if ( ! mcsharpBitMaskGetsendResult.match ( mcsharp_mask_Get ) ) goto now;
  later:
   mcsharpQueueGet.yield ( mcsharpQueueGet );
   if ( mcsharpQueueGet.empty )
    mcsharpBitMaskGetsendResult.clear ( mcsharp_mask_Get );
  now:
   if ( mcsharpBitMaskGetsendResult.match ( 
    mcsharp_mask_sendResult ) )   {
    object[] osendResult = ( object[] ) sendResult.Dequeue();
    int countPrimes = ( int ) osendResult [ 0 ];
    if ( sendResult.Count == 0 )
         mcsharpBitMaskGetsendResult.clear ( mcsharp_mask_sendResult );
    scanGetsendResult ();
    Monitor.Exit ( mcsharpQueueGet );
     {
   totalCountPrimes = totalCountPrimes + countPrimes  ;
 return totalCountPrimes  ;
  }
   }
   else {
    mcsharpBitMaskGetsendResult.set ( mcsharp_mask_Get );
    goto later;
  }

 }
static  void Main (  string[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  string[] args )  {
   int n = 0  ;

  int p = 0  ;

  if ( args.Length  >= 2  )
    {
   n = Convert.ToInt32( args[ 0   ]   )  ;
 p = Convert.ToInt32( args[ 1   ]   )  ;
 if ( args.Length  == 3   )
   PrintPrimes = args[ 2   ]  == "verb"   ? true   : false   ;

  }

  else
  {
   Console.WriteLine( Usage( )   )  ;
 return ;
  }
 
 DateTime dt1 = DateTime.Now  ;

  ParallelCountPrimes( n   , p   )  ;
 DateTime dt2 = DateTime.Now  ;

  Console.WriteLine( "#primes from [2.." + n + ") = " + totalCountPrimes + " (" + ( dt2 - dt1   ).TotalSeconds + " sec with " + p + "-threads)"   )  ;
 }
static  string Usage (  )   {
   string pname = System.Reflection.Assembly.GetEntryAssembly( ).GetName( ).Name  ;

  StringBuilder s = new StringBuilder ( )   ;

  for ( int i = 0  ;

  i  < Console.WindowWidth ; i++   )
 s.Append( "-"   )  ;

  return ( s.ToString( ) + Environment.NewLine + "Usage: " + pname + " n p [verb]" + Environment.NewLine + "where" + Environment.NewLine + " n -  upper excluded bound of numbers [2...n)" + Environment.NewLine + " p -  threads number" + Environment.NewLine + " verb - verbosity" + Environment.NewLine + s.ToString( ) + Environment.NewLine   )  ;
  }
}

}